/*
 * ReachableStates.h
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef EFFICIENT_REACHABLE_STATES_H_
#define EFFICIENT_REACHABLE_STATES_H_

#include <core/multipleDispatch.hpp>
#include <algorithm>
#include <deque>
#include <set>

#include <automaton/Automaton.h>
#include <automaton/AutomatonFeatures.h>

#include <label/Label.h>

namespace automaton {

namespace properties {

namespace efficient {

class ReachableStates : public std::SingleDispatch<ReachableStates, std::set<label::Label>, const automaton::AutomatonBase &> {
public:
	static std::set<label::Label> reachableStates( const automaton::Automaton & automaton );

	/**
	 * Removes dead states from FSM. Melichar 2.29
	 */
	template<class T>
	static std::set<label::Label> reachableStates( const T & fsm );
};

} /* namespace efficient */

} /* namespace properties */

} /* namespace automaton */

#endif /* EFFICIENT_REACHABLE_STATES_H_ */
